$(() => {
const BASE_PATH = 'https://js.devexpress.com/Demos/NetCore/';
const url = `${BASE_PATH}api/DataGridCollaborativeEditing/`;
const groupId = new DevExpress.data.Guid().toJSON();
const createStore = function () {
return DevExpress.data.AspNet.createStore({
key: 'ID',
loadUrl: url,
insertUrl: url,
updateUrl: url,
deleteUrl: url,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.data.groupId = groupId;
},
});
};
const createDataGrid = function (gridId, store) {
$(`#${gridId}`).dxDataGrid({
dataSource: store,
height: 600,
showBorders: true,
repaintChangesOnly: true,
highlightChanges: true,
paging: {
enabled: false,
},
editing: {
mode: 'cell',
refreshMode: 'reshape',
allowUpdating: true,
allowDeleting: true,
allowAdding: true,
useIcons: true,
},
columns: [
{
dataField: 'Prefix',
caption: 'Title',
width: 50,
validationRules: [{ type: 'required' }],
},
{
dataField: 'FirstName',
validationRules: [{ type: 'required' }],
},
{
dataField: 'StateID',
caption: 'State',
lookup: {
dataSource: DevExpress.data.AspNet.createStore({
key: 'ID',
loadUrl: `${BASE_PATH}api/DataGridStatesLookup`,
}),
displayExpr: 'Name',
valueExpr: 'ID',
},
validationRules: [{ type: 'required' }],
},
{
dataField: 'BirthDate',
dataType: 'date',
validationRules: [{
type: 'range',
max: new Date(3000, 0),
message: 'Date can not be greater than 01/01/3000',
}],
},
],
});
};
const store1 = createStore();
const store2 = createStore();
const updateStores = function (events) {
store1.push(events);
store2.push(events);
};
createDataGrid('grid1', store1);
createDataGrid('grid2', store2);
const hubUrl = `${BASE_PATH}dataGridCollaborativeEditingHub?GroupId=${groupId}`;
const connection = new signalR.HubConnectionBuilder()
.withUrl(hubUrl, {
skipNegotiation: true,
transport: signalR.HttpTransportType.WebSockets,
})
.configureLogging(signalR.LogLevel.Information)
.build();
connection.start()
.then(() => {
connection.on('update', (key, data) => {
updateStores([{ type: 'update', key, data }]);
});
connection.on('insert', (data) => {
updateStores([{ type: 'insert', data }]);
});
connection.on('remove', (key) => {
updateStores([{ type: 'remove', key }]);
});
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.6/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/23.1.6/js/dx.all.js"></script>
<script src="js/signalr.js"></script>
<script src="https://unpkg.com/devextreme-aspnet-data@2.9.2/js/dx.aspnet.data.js"></script>
<script src="index.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="tables">
<div class="column">
<div id="grid1"></div>
</div>
<div class="column">
<div id="grid2"></div>
</div>
</div>
</div>
</body>
</html>
.tables {
display: flex;
}
.column:first-child {
width: 50%;
padding-right: 15px;
}
.column:last-child {
width: 50%;
padding-left: 15px;
}
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using DevExtreme.MVC.Demos.Hubs;
using DevExtreme.MVC.Demos.Models.DataGrid;
using DevExtreme.MVC.Demos.Models.SampleData;
using Microsoft.AspNet.SignalR;
using Newtonsoft.Json;
using System;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web.Http;
namespace DevExtreme.MVC.Demos.Controllers.ApiControllers {
public class DataGridCollaborativeEditingController : ApiController {
static readonly Random random = new Random();
IHubContext hubContext;
public DataGridCollaborativeEditingController() {
hubContext = GlobalHost.ConnectionManager.GetHubContext<DataGridCollaborativeEditingHub>();
}
[HttpGet]
public object Get(DataSourceLoadOptions loadOptions) {
return DataSourceLoader.Load(SampleData.DataGridEmployees, loadOptions);
}
[HttpPost]
public HttpResponseMessage Post(FormDataCollection form) {
var values = form.Get("values");
var groupId = form.Get("groupId");
var newEmployee = new Employee();
JsonConvert.PopulateObject(values, newEmployee);
newEmployee.ID = random.Next(int.MaxValue);
Validate(newEmployee);
if(!ModelState.IsValid) {
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
}
// db.Employees.Add(newEmployee);
// db.SaveChanges();
hubContext.Clients.Group(groupId).insert(newEmployee);
return Request.CreateResponse(newEmployee);
}
[HttpPut]
public HttpResponseMessage Put(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var groupId = form.Get("groupId");
var employee = new Employee();
JsonConvert.PopulateObject(values, employee);
employee.ID = key;
Validate(employee);
if(!ModelState.IsValid) {
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
}
// db.SaveChanges();
hubContext.Clients.Group(groupId).update(key, employee);
return Request.CreateResponse(employee);
}
[HttpDelete]
public void Delete(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var groupId = form.Get("groupId");
// var employee = db.Employees.First(a => a.ID == key);
// db.Employees.Remove(employee);
// db.SaveChanges();
hubContext.Clients.Group(groupId).remove(key);
}
}
}
using Microsoft.AspNet.SignalR;
using System.Threading.Tasks;
namespace DevExtreme.MVC.Demos.Hubs {
public class DataGridCollaborativeEditingHub : Hub {
public override Task OnConnected() {
var groupId = Context.QueryString["GroupId"];
Groups.Add(Context.ConnectionId, groupId);
return base.OnConnected();
}
}
}

<template>
<div class="tables">
<Grid
:data-source="store1"
class="column"
/>
<Grid
:data-source="store2"
class="column"
/>
</div>
</template>
<script setup lang="ts">
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
import Guid from 'devextreme/core/guid';
import Grid from './Grid.vue';
const BASE_PATH = 'https://js.devexpress.com/Demos/NetCore/';
const url = `${BASE_PATH}api/DataGridCollaborativeEditing/`;
const groupId = new Guid().toString();
const createStore = () => AspNetData.createStore({
key: 'ID',
loadUrl: url,
insertUrl: url,
updateUrl: url,
deleteUrl: url,
onBeforeSend(operation, ajaxSettings) {
ajaxSettings.data.groupId = groupId;
},
});
const store1 = createStore();
const store2 = createStore();
const updateStores = (events: any[]) => {
store1.push(events);
store2.push(events);
};
const hubUrl = `${BASE_PATH}dataGridCollaborativeEditingHub?GroupId=${groupId}`;
const connection = new HubConnectionBuilder()
.withUrl(hubUrl, {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
connection.start()
.then(() => {
connection.on('update', (key, data) => {
updateStores([{ type: 'update', key, data }]);
});
connection.on('insert', (data) => {
updateStores([{ type: 'insert', data }]);
});
connection.on('remove', (key) => {
updateStores([{ type: 'remove', key }]);
});
});
</script>
<style scoped>
.tables {
display: flex;
}
.column:first-child {
width: 50%;
padding-right: 15px;
}
.column:last-child {
width: 50%;
padding-left: 15px;
}
</style>
<template>
<DxDataGrid
:data-source="dataSource"
:height="600"
:show-borders="true"
:repaint-changes-only="true"
:highlight-changes="true"
>
<DxPaging
:enabled="false"
/>
<DxEditing
:allow-deleting="true"
:allow-updating="true"
:allow-adding="true"
:use-icons="true"
mode="cell"
refresh-mode="reshape"
/>
<DxColumn
:width="50"
data-field="Prefix"
caption="Title"
>
<DxRequiredRule/>
</DxColumn>
<DxColumn
data-field="FirstName"
>
<DxRequiredRule/>
</DxColumn>
<DxColumn
:lookup="lookup"
data-field="StateID"
caption="State"
>
<DxRequiredRule/>
</DxColumn>
<DxColumn
data-field="BirthDate"
data-type="date"
>
<DxRangeRule
:max="maxDate"
message="Date can not be greater than 01/01/3000"
/>
</DxColumn>
</DxDataGrid>
</template>
<script setup lang="ts">
import {
DxDataGrid, DxColumn, DxPaging, DxEditing, DxRequiredRule, DxRangeRule, type DxDataGridTypes,
} from 'devextreme-vue/data-grid';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
import { CustomStore } from 'devextreme-vue/common/data';
defineProps<{
dataSource: CustomStore
}>();
const statesStore = AspNetData.createStore({
key: 'ID',
loadUrl: 'https://js.devexpress.com/Demos/NetCore/api/DataGridStatesLookup',
});
const maxDate = new Date(3000, 0);
const lookup: DxDataGridTypes.ColumnLookup = {
dataSource: statesStore,
displayExpr: 'Name',
valueExpr: 'ID',
};
</script>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'@aspnet/signalr': 'npm:@aspnet/signalr@1.0.27/dist/cjs',
'tslib': 'npm:tslib/tslib.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.0.0/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'@aspnet/signalr': {
main: 'index.js',
defaultExtension: 'js',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using DevExtreme.MVC.Demos.Hubs;
using DevExtreme.MVC.Demos.Models.DataGrid;
using DevExtreme.MVC.Demos.Models.SampleData;
using Microsoft.AspNet.SignalR;
using Newtonsoft.Json;
using System;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web.Http;
using DevExpress.Data.Utils;
namespace DevExtreme.MVC.Demos.Controllers.ApiControllers {
public class DataGridCollaborativeEditingController : ApiController {
static readonly NonCryptographicRandom random = NonCryptographicRandom.System;
IHubContext hubContext;
public DataGridCollaborativeEditingController() {
hubContext = GlobalHost.ConnectionManager.GetHubContext<DataGridCollaborativeEditingHub>();
}
[HttpGet]
public object Get(DataSourceLoadOptions loadOptions) {
return DataSourceLoader.Load(SampleData.DataGridEmployees, loadOptions);
}
[HttpPost]
public HttpResponseMessage Post(FormDataCollection form) {
var values = form.Get("values");
var groupId = form.Get("groupId");
var newEmployee = new Employee();
JsonConvert.PopulateObject(values, newEmployee);
newEmployee.ID = random.Next(int.MaxValue);
Validate(newEmployee);
if(!ModelState.IsValid) {
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
}
// db.Employees.Add(newEmployee);
// db.SaveChanges();
hubContext.Clients.Group(groupId).insert(newEmployee);
return Request.CreateResponse(newEmployee);
}
[HttpPut]
public HttpResponseMessage Put(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var groupId = form.Get("groupId");
var employee = new Employee();
JsonConvert.PopulateObject(values, employee);
employee.ID = key;
Validate(employee);
if(!ModelState.IsValid) {
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
}
// db.SaveChanges();
hubContext.Clients.Group(groupId).update(key, employee);
return Request.CreateResponse(employee);
}
[HttpDelete]
public void Delete(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var groupId = form.Get("groupId");
// var employee = db.Employees.First(a => a.ID == key);
// db.Employees.Remove(employee);
// db.SaveChanges();
hubContext.Clients.Group(groupId).remove(key);
}
}
}
using Microsoft.AspNet.SignalR;
using System.Threading.Tasks;
namespace DevExtreme.MVC.Demos.Hubs {
public class DataGridCollaborativeEditingHub : Hub {
public override Task OnConnected() {
var groupId = Context.QueryString["GroupId"];
Groups.Add(Context.ConnectionId, groupId);
return base.OnConnected();
}
}
}

import React, { useEffect } from 'react';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
import Guid from 'devextreme/core/guid';
import Grid from './Grid.tsx';
const BASE_PATH = 'https://js.devexpress.com/Demos/NetCore/';
const url = `${BASE_PATH}api/DataGridCollaborativeEditing`;
const groupId = new Guid().toString();
interface Change {
type: 'insert' | 'update' | 'remove';
data?: any;
key?: any;
}
const createStore = () => AspNetData.createStore({
key: 'ID',
loadUrl: url,
insertUrl: url,
updateUrl: url,
deleteUrl: url,
onBeforeSend(operation, ajaxSettings) {
ajaxSettings.data.groupId = groupId;
},
});
const store1 = createStore();
const store2 = createStore();
const updateStores = (events: Change[]) => {
store1.push(events);
store2.push(events);
};
const App = () => {
useEffect(() => {
const hubUrl = `${BASE_PATH}dataGridCollaborativeEditingHub?GroupId=${groupId}`;
const connection = new HubConnectionBuilder()
.withUrl(hubUrl, {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
connection.start()
.then(() => {
connection.on('update', (key, data) => {
updateStores([{ type: 'update', key, data }]);
});
connection.on('insert', (data) => {
updateStores([{ type: 'insert', data }]);
});
connection.on('remove', (key) => {
updateStores([{ type: 'remove', key }]);
});
});
}, []);
return (
<div className="tables">
<div className="column">
<Grid dataSource={store1} />
</div>
<div className="column">
<Grid dataSource={store2} />
</div>
</div>
);
};
export default App;
import React, { useEffect } from 'react';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
import Guid from 'devextreme/core/guid';
import Grid from './Grid.js';
const BASE_PATH = 'https://js.devexpress.com/Demos/NetCore/';
const url = `${BASE_PATH}api/DataGridCollaborativeEditing`;
const groupId = new Guid().toString();
const createStore = () =>
AspNetData.createStore({
key: 'ID',
loadUrl: url,
insertUrl: url,
updateUrl: url,
deleteUrl: url,
onBeforeSend(operation, ajaxSettings) {
ajaxSettings.data.groupId = groupId;
},
});
const store1 = createStore();
const store2 = createStore();
const updateStores = (events) => {
store1.push(events);
store2.push(events);
};
const App = () => {
useEffect(() => {
const hubUrl = `${BASE_PATH}dataGridCollaborativeEditingHub?GroupId=${groupId}`;
const connection = new HubConnectionBuilder()
.withUrl(hubUrl, {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
connection.start().then(() => {
connection.on('update', (key, data) => {
updateStores([{ type: 'update', key, data }]);
});
connection.on('insert', (data) => {
updateStores([{ type: 'insert', data }]);
});
connection.on('remove', (key) => {
updateStores([{ type: 'remove', key }]);
});
});
}, []);
return (
<div className="tables">
<div className="column">
<Grid dataSource={store1} />
</div>
<div className="column">
<Grid dataSource={store2} />
</div>
</div>
);
};
export default App;
import React from 'react';
import DataGrid, {
Column, Editing, Paging, RequiredRule, RangeRule, Lookup,
} from 'devextreme-react/data-grid';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
const maxDate = new Date(3000, 0);
const statesStore = AspNetData.createStore({
key: 'ID',
loadUrl: 'https://js.devexpress.com/Demos/NetCore/api/DataGridStatesLookup',
});
const Grid = (props) => (
<DataGrid
dataSource={props.dataSource}
height={600}
showBorders={true}
repaintChangesOnly={true}
highlightChanges={true}
>
<Paging
enabled={false}
/>
<Editing
mode="cell"
refreshMode="reshape"
allowUpdating={true}
allowDeleting={true}
allowAdding={true}
useIcons={true}
/>
<Column
dataField="Prefix"
caption="Title"
width={50}
>
<RequiredRule />
</Column>
<Column
dataField="FirstName"
>
<RequiredRule />
</Column>
<Column
dataField="StateID"
caption="State"
>
<Lookup
dataSource={statesStore}
displayExpr="Name"
valueExpr="ID"
/>
<RequiredRule />
</Column>
<Column
dataField="BirthDate"
dataType="date"
>
<RangeRule
max={maxDate}
message="Date can not be greater than 01/01/3000"
/>
</Column>
</DataGrid>
);
export default Grid;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'@aspnet/signalr': 'npm:@aspnet/signalr@1.0.27/dist/cjs',
'tslib': 'npm:tslib/tslib.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.0.0/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'@aspnet/signalr': {
main: 'index.js',
defaultExtension: 'js',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import DataGrid, {
Column,
Editing,
Paging,
RequiredRule,
RangeRule,
Lookup,
} from 'devextreme-react/data-grid';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
const maxDate = new Date(3000, 0);
const statesStore = AspNetData.createStore({
key: 'ID',
loadUrl: 'https://js.devexpress.com/Demos/NetCore/api/DataGridStatesLookup',
});
const Grid = (props) => (
<DataGrid
dataSource={props.dataSource}
height={600}
showBorders={true}
repaintChangesOnly={true}
highlightChanges={true}
>
<Paging enabled={false} />
<Editing
mode="cell"
refreshMode="reshape"
allowUpdating={true}
allowDeleting={true}
allowAdding={true}
useIcons={true}
/>
<Column
dataField="Prefix"
caption="Title"
width={50}
>
<RequiredRule />
</Column>
<Column dataField="FirstName">
<RequiredRule />
</Column>
<Column
dataField="StateID"
caption="State"
>
<Lookup
dataSource={statesStore}
displayExpr="Name"
valueExpr="ID"
/>
<RequiredRule />
</Column>
<Column
dataField="BirthDate"
dataType="date"
>
<RangeRule
max={maxDate}
message="Date can not be greater than 01/01/3000"
/>
</Column>
</DataGrid>
);
export default Grid;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.7/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.tables {
display: flex;
}
.column:first-child {
width: 50%;
padding-right: 15px;
}
.column:last-child {
width: 50%;
padding-left: 15px;
}
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using DevExtreme.MVC.Demos.Hubs;
using DevExtreme.MVC.Demos.Models.DataGrid;
using DevExtreme.MVC.Demos.Models.SampleData;
using Microsoft.AspNet.SignalR;
using Newtonsoft.Json;
using System;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web.Http;
using DevExpress.Data.Utils;
namespace DevExtreme.MVC.Demos.Controllers.ApiControllers {
public class DataGridCollaborativeEditingController : ApiController {
static readonly NonCryptographicRandom random = NonCryptographicRandom.System;
IHubContext hubContext;
public DataGridCollaborativeEditingController() {
hubContext = GlobalHost.ConnectionManager.GetHubContext<DataGridCollaborativeEditingHub>();
}
[HttpGet]
public object Get(DataSourceLoadOptions loadOptions) {
return DataSourceLoader.Load(SampleData.DataGridEmployees, loadOptions);
}
[HttpPost]
public HttpResponseMessage Post(FormDataCollection form) {
var values = form.Get("values");
var groupId = form.Get("groupId");
var newEmployee = new Employee();
JsonConvert.PopulateObject(values, newEmployee);
newEmployee.ID = random.Next(int.MaxValue);
Validate(newEmployee);
if(!ModelState.IsValid) {
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
}
// db.Employees.Add(newEmployee);
// db.SaveChanges();
hubContext.Clients.Group(groupId).insert(newEmployee);
return Request.CreateResponse(newEmployee);
}
[HttpPut]
public HttpResponseMessage Put(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var groupId = form.Get("groupId");
var employee = new Employee();
JsonConvert.PopulateObject(values, employee);
employee.ID = key;
Validate(employee);
if(!ModelState.IsValid) {
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
}
// db.SaveChanges();
hubContext.Clients.Group(groupId).update(key, employee);
return Request.CreateResponse(employee);
}
[HttpDelete]
public void Delete(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var groupId = form.Get("groupId");
// var employee = db.Employees.First(a => a.ID == key);
// db.Employees.Remove(employee);
// db.SaveChanges();
hubContext.Clients.Group(groupId).remove(key);
}
}
}
using Microsoft.AspNet.SignalR;
using System.Threading.Tasks;
namespace DevExtreme.MVC.Demos.Hubs {
public class DataGridCollaborativeEditingHub : Hub {
public override Task OnConnected() {
var groupId = Context.QueryString["GroupId"];
Groups.Add(Context.ConnectionId, groupId);
return base.OnConnected();
}
}
}

<div class="tables">
<div *ngFor="let dataSource of dataSources" class="column">
<dx-data-grid
[dataSource]="dataSource"
[height]="600"
[showBorders]="true"
[repaintChangesOnly]="true"
[highlightChanges]="true"
>
<dxo-paging [enabled]="false"> </dxo-paging>
<dxo-editing
mode="cell"
refreshMode="reshape"
[allowUpdating]="true"
[allowDeleting]="true"
[allowAdding]="true"
[useIcons]="true"
>
</dxo-editing>
<dxi-column dataField="Prefix" caption="Title" [width]="50">
<dxi-validation-rule type="required"> </dxi-validation-rule>
</dxi-column>
<dxi-column dataField="FirstName">
<dxi-validation-rule type="required"> </dxi-validation-rule>
</dxi-column>
<dxi-column dataField="StateID" caption="State">
<dxi-validation-rule type="required"> </dxi-validation-rule>
<dxo-lookup
[dataSource]="stateDataSource"
displayExpr="Name"
valueExpr="ID"
>
</dxo-lookup>
</dxi-column>
<dxi-column dataField="BirthDate" dataType="date">
<dxi-validation-rule
type="range"
[max]="maxDate"
message="Date can not be greater than 01/01/3000"
>
</dxi-validation-rule>
</dxi-column>
</dx-data-grid>
</div>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxDataGridModule, DxTextBoxModule } from 'devextreme-angular';
import { CustomStore } from 'devextreme-angular/common/data';
import { CollaborativeEditingService } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
preserveWhitespaces: true,
providers: [CollaborativeEditingService],
})
export class AppComponent {
dataSources: Array<CustomStore>;
stateDataSource: CustomStore;
maxDate: Date = new Date(3000, 0);
constructor(private service: CollaborativeEditingService) {
this.dataSources = [this.service.createStore(), this.service.createStore()];
this.stateDataSource = this.service.createStatesStore();
this.service.getStoreChangedObservable().subscribe((events) => {
this.dataSources.forEach((store) => store.push(events));
});
}
}
@NgModule({
imports: [
BrowserModule,
DxDataGridModule,
DxTextBoxModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
.tables {
display: flex;
}
.column:first-child {
width: 50%;
padding-right: 15px;
}
.column:last-child {
width: 50%;
padding-left: 15px;
}
import { Injectable } from '@angular/core';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
import Guid from 'devextreme/core/guid';
import { Subject } from 'rxjs';
const BASE_PATH = 'https://js.devexpress.com/Demos/NetCore/';
class StoreChangedEvent {
type: 'update' | 'insert' | 'remove';
key?: string;
data?: Record<string, unknown>;
}
@Injectable()
export class CollaborativeEditingService {
private storeChanged = new Subject<Array<StoreChangedEvent>>();
private groupId: string = new Guid().toString();
private connection: Object;
getStoreChangedObservable() {
this.connection || this.initHubConnection();
return this.storeChanged.asObservable();
}
createStatesStore() {
return AspNetData.createStore({
key: 'ID',
loadUrl: `${BASE_PATH}api/DataGridStatesLookup`,
});
}
createStore() {
const url = `${BASE_PATH}api/DataGridCollaborativeEditing`;
return AspNetData.createStore({
key: 'ID',
loadUrl: url,
insertUrl: url,
updateUrl: url,
deleteUrl: url,
onBeforeSend: (operation, ajaxSettings) => {
ajaxSettings.data.groupId = this.groupId;
},
});
}
private initHubConnection() {
const connection = this.createConnection();
connection.start()
.then(() => {
connection.on('update', (key, data) => {
this.storeChanged.next([{ type: 'update', key, data }]);
});
connection.on('insert', (data) => {
this.storeChanged.next([{ type: 'insert', data }]);
});
connection.on('remove', (key) => {
this.storeChanged.next([{ type: 'remove', key }]);
});
});
}
private createConnection() {
const hubUrl = `${BASE_PATH}dataGridCollaborativeEditingHub?GroupId=${this.groupId}`;
return new HubConnectionBuilder()
.withUrl(hubUrl, {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'@aspnet/signalr': 'npm:@aspnet/signalr@1.0.27/dist/cjs/index.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.0.0/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.24/package.json',
'npm:devexpress-gantt@4.1.64/package.json',
'npm:@aspnet/*/package.json',
],
};
System.config(window.config);
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "17.3.12"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.4.5"
},
"zone.js": {
"version": "0.14.10"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.14.10/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using DevExtreme.MVC.Demos.Hubs;
using DevExtreme.MVC.Demos.Models.DataGrid;
using DevExtreme.MVC.Demos.Models.SampleData;
using Microsoft.AspNet.SignalR;
using Newtonsoft.Json;
using System;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web.Http;
using DevExpress.Data.Utils;
namespace DevExtreme.MVC.Demos.Controllers.ApiControllers {
public class DataGridCollaborativeEditingController : ApiController {
static readonly NonCryptographicRandom random = NonCryptographicRandom.System;
IHubContext hubContext;
public DataGridCollaborativeEditingController() {
hubContext = GlobalHost.ConnectionManager.GetHubContext<DataGridCollaborativeEditingHub>();
}
[HttpGet]
public object Get(DataSourceLoadOptions loadOptions) {
return DataSourceLoader.Load(SampleData.DataGridEmployees, loadOptions);
}
[HttpPost]
public HttpResponseMessage Post(FormDataCollection form) {
var values = form.Get("values");
var groupId = form.Get("groupId");
var newEmployee = new Employee();
JsonConvert.PopulateObject(values, newEmployee);
newEmployee.ID = random.Next(int.MaxValue);
Validate(newEmployee);
if(!ModelState.IsValid) {
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
}
// db.Employees.Add(newEmployee);
// db.SaveChanges();
hubContext.Clients.Group(groupId).insert(newEmployee);
return Request.CreateResponse(newEmployee);
}
[HttpPut]
public HttpResponseMessage Put(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var groupId = form.Get("groupId");
var employee = new Employee();
JsonConvert.PopulateObject(values, employee);
employee.ID = key;
Validate(employee);
if(!ModelState.IsValid) {
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
}
// db.SaveChanges();
hubContext.Clients.Group(groupId).update(key, employee);
return Request.CreateResponse(employee);
}
[HttpDelete]
public void Delete(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var groupId = form.Get("groupId");
// var employee = db.Employees.First(a => a.ID == key);
// db.Employees.Remove(employee);
// db.SaveChanges();
hubContext.Clients.Group(groupId).remove(key);
}
}
}
using Microsoft.AspNet.SignalR;
using System.Threading.Tasks;
namespace DevExtreme.MVC.Demos.Hubs {
public class DataGridCollaborativeEditingHub : Hub {
public override Task OnConnected() {
var groupId = Context.QueryString["GroupId"];
Groups.Add(Context.ConnectionId, groupId);
return base.OnConnected();
}
}
}